package com.example.libreria;

import java.util.Vector;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.RatingBar;
import android.widget.TextView;

import com.example.libreria.controller.BookController;
import com.example.libreria.entities.Book;

public class AdaptadorBooks extends BaseAdapter {
	private LayoutInflater inflador; // Crea Layouts a partir del XML
	TextView titulo, autor;
	RatingBar valoracion;
	Vector<Book> books;

	public AdaptadorBooks(Context contexto) {
		inflador = (LayoutInflater) contexto
				.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
		books = BookController.listBooks("titulo");
	}

	@Override
	public View getView(int posicion, View vistaReciclada, ViewGroup padre) {
		Book b = books.get(posicion);
		if (vistaReciclada == null) {
			vistaReciclada = inflador.inflate(R.layout.elemento_lista, null);
		}
		titulo = (TextView) vistaReciclada.findViewById(R.id.titulo);
		autor = (TextView) vistaReciclada.findViewById(R.id.autor);
		valoracion = (RatingBar) vistaReciclada.findViewById(R.id.valoracion);

		titulo.setText(b.getTitulo());
		autor.setText(b.getAutor());
		valoracion.setRating(b.getValoracion());
		return vistaReciclada;
	}

	@Override
	public int getCount() {
		return BookController.size();
	}

	@Override
	public Object getItem(int posicion) {
		return books.get(posicion);
	}

	@Override
	public long getItemId(int posicion) {
		return books.get(posicion).getId();
	}

	public void sort(String orden) {
		books = BookController.listBooks(orden);
		notifyDataSetChanged();
	}
}