package com.example.libreria;

import java.util.Vector;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.example.libreria.controller.ContactController;
import com.example.libreria.controller.LoanController;
import com.example.libreria.entities.Loan;

public class AdaptadorLoans extends BaseAdapter {
	private LayoutInflater inflador; // Crea Layouts a partir del XML
	TextView titulo, name, date;
	Vector<Loan> loans;


	public AdaptadorLoans(Context contexto) {
		
		inflador = (LayoutInflater) contexto
				.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
		loans = LoanController.listLoans("date");
	}

	public View getView(int posicion, View vistaReciclada, ViewGroup padre) {
		Loan l = loans.get(posicion);
		if (vistaReciclada == null) {
			vistaReciclada = inflador.inflate(R.layout.elemento_lista_loan,
					null);
		}
		
		
		titulo = (TextView) vistaReciclada.findViewById(R.id.titulo);
		name = (TextView) vistaReciclada.findViewById(R.id.name);
		date = (TextView) vistaReciclada.findViewById(R.id.date);

		
		
		titulo.setText(l.getBook().getTitulo());
		name.setText(ContactController.getContact(l.getContactid()).getName());		
		date.setText(android.text.format.DateFormat.format(MainActivity.pref.getString("formatoFecha", "dd-MM-yyyy"), l.getDate()));

		return vistaReciclada;
	}

	public int getCount() {
		return LoanController.size();
	}

	public Object getItem(int posicion) {
		return loans.get(posicion);
	}

	public long getItemId(int posicion) {
		return loans.get(posicion).getId();
	}

	public void sort(String orden) {
		loans = LoanController.listLoans(orden);
		notifyDataSetChanged();
	}

}