package com.example.libreria;

import android.app.ListActivity;
import android.content.Intent;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.ListView;

public class BookList extends ListActivity {

	public AdaptadorBooks adaptador;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		// setContentView(R.layout.edicion_lugar);
		setContentView(R.layout.book_list);
		adaptador = new AdaptadorBooks(this);
		setListAdapter(adaptador);
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {

		getMenuInflater().inflate(R.menu.menu_book_list, menu);

		return true;
		/** true -> el men ya est visible */

	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {

		switch (item.getItemId()) {
		case R.id.orderTitle:
			adaptador.sort("titulo");
			break;
		case R.id.orderRating:
			adaptador.sort("valoracion");
			break;
		}
		return true;
		/** true -> consumimos el item, no se propaga */
	}


	
	@Override
	protected void onListItemClick(ListView listView, View vista, int posicion, long id){
	   super.onListItemClick(listView, vista, posicion, id);
	   Intent i = new Intent(this, BookView.class);
	   i.putExtra("id", (int) id);
	   startActivity(i);
	}
	
	@Override
	protected void onResume() {

	   super.onResume();
	   this.onCreate(null);
	}
}
