package com.example.libreria.DAO;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;

public class LibreriaSQLiteHelper extends SQLiteOpenHelper {

	public LibreriaSQLiteHelper(Context context) {
		super(context, "libreria", null, 1);
	}

	@Override
	public void onCreate(SQLiteDatabase db) {
		db.execSQL("CREATE TABLE book ("
				+ "_id INTEGER PRIMARY KEY AUTOINCREMENT, "
				+ "titulo TEXT, " 
				+ "isbn TEXT, " 
				+ "autor TEXT, " 
				+ "paginas INTEGER, "
				+ "estado TEXT, "
				+ "valoracion LONG)");
		
		db.execSQL("CREATE TABLE loan ("
				+ "_id INTEGER PRIMARY KEY AUTOINCREMENT, "
				+ "bookid INTEGER, " 
				+ "contactid INTEGER, " 
				+ "date DATE, " 
				+ "name TEXT,"
				+ "FOREIGN KEY (bookid) REFERENCES book (_id))");
	}

	@Override
	public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
		// En caso de una nueva versin habra que actualizar las tablas
	}
}