package com.example.libreria;

import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.support.v7.app.ActionBarActivity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;

import com.example.libreria.controller.BookController;
import com.example.libreria.controller.ContactController;
import com.example.libreria.controller.LoanController;

public class MainActivity extends ActionBarActivity {

	private Button btnAdd, btnList, btnLoans;
	private TextView textCount;
	public static SharedPreferences pref;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);

		BookController.activity = this;
		LoanController.activity = this;
		ContactController.ac = this;
		pref = this.getSharedPreferences("com.example.libreria_preferences",
				Context.MODE_PRIVATE);

		btnAdd = (Button) findViewById(R.id.btnAdd);
		btnList = (Button) findViewById(R.id.btnList);
		btnLoans = (Button) findViewById(R.id.btnLoans);

		textCount = (TextView) findViewById(R.id.textCount);
		textCount.setText("Hay " + BookController.size() + " libros.");

		btnAdd.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				AddBook();
			}
		});

		btnList.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				ListBooks();
			}
		});

		btnLoans.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				LoanBooks();
			}
		});

	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// Handle action bar item clicks here. The action bar will
		// automatically handle clicks on the Home/Up button, so long
		// as you specify a parent activity in AndroidManifest.xml.
		int id = item.getItemId();
		switch (id) {
		case R.id.action_settings:
			showPreferences(null);
			break;
		case R.id.menuAbout:
			showAbout(null);
			break;
		case R.id.menuEstadisticas:
			showStats(null);
			break;
		}

		return super.onOptionsItemSelected(item);
	}

	@Override
	protected void onResume() {

		super.onResume();
		textCount.setText("Hay " + BookController.size() + " libros.");
	}

	private void AddBook() {
		Intent intent = new Intent(this, BookEdit.class);
		startActivity(intent);
	}

	private void ListBooks() {
		Intent intent = new Intent(this, BookList.class);
		startActivity(intent);
	}

	private void LoanBooks() {
		Intent intent = new Intent(this, LoanList.class);
		startActivity(intent);
	}

	public void showAbout(View view) {
		Intent i = new Intent(this, AcercaDe.class);
		startActivity(i);
	}

	public void showPreferences(View view) {
		Intent i = new Intent(this, Preferences.class);
		startActivity(i);
	}
	
	public void showStats(View view) {
		Intent i = new Intent(this, Estadisticas.class);
		startActivity(i);
	}
}
