package com.example.libreria.Util;

import java.io.IOException;

import org.apache.http.HttpResponse;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.util.EntityUtils;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import com.example.libreria.entities.Book;

public class ISBN {

	private static Book book;
	private static String error;

	public static Book callISBNService(String isbn) {
		String respStr;

		book = null;

		HttpClient httpClient = new DefaultHttpClient();
		HttpGet get = new HttpGet(
				"https://www.googleapis.com/books/v1/volumes?q=isbn:" + isbn);
		// get.setHeader("content-type", "application/json");

		HttpResponse resp;
		try {
			resp = httpClient.execute(get);
			respStr = EntityUtils.toString(resp.getEntity());

			JSONObject respJSON = new JSONObject(respStr);

			book = MapJSON2Book(respJSON);

		} catch (ClientProtocolException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		return book;

	}

	private static Book MapJSON2Book(JSONObject respJSON) {

		Book b = new Book();
		String autores = "";

		JSONArray arr, arrAuthors;
		try {
			arr = respJSON.getJSONArray("items");

			// for (int i = 0; i < arr.length(); i++)
			int i = 0;
			{
				b.setTitulo(arr.getJSONObject(i).getJSONObject("volumeInfo")
						.getString("title"));
				arrAuthors = arr.getJSONObject(i).getJSONObject("volumeInfo").getJSONArray("authors");
				for (int j = 0; j < arrAuthors.length(); j++) {
					if(autores.length()>0)
						autores += ", ";
					autores += arrAuthors.getString(j);
				}
				b.setAutor(autores);
				
				//b.setAutor(arr.getJSONObject(i).getJSONObject("volumeInfo")
				//		.getString("authors"));
				
				b.setPaginas(arr.getJSONObject(i).getJSONObject("volumeInfo")
						.getInt("pageCount"));
				
				error = "";
			}
		} catch (JSONException e) {
			// TODO Auto-generated catch block
			error = e.getMessage();
			e.printStackTrace();
		}
		return b;

	}

	public static Book getBook() {
		return book;
	}
	
	public static String getError() {
		return error;
	}

}
