package com.example.libreria.controller;

import java.util.Vector;

import android.app.Activity;
import android.content.ContentUris;
import android.content.ContentValues;
import android.database.Cursor;
import android.net.Uri;
import android.util.Log;
import android.widget.Toast;

import com.example.libreria.entities.Book;

public class BookController {

	public static Activity activity;
	private static Uri uri;

	public BookController(Activity activity) {
		BookController.activity = activity;
	}

	public static Book elemento(int id) {	
		Book b = new Book();
		Uri uri = Uri.parse(
                "content://com.example.booksprovider/book/"+id);
		
		Cursor cursor = activity.getContentResolver().query(uri, null, null,
				null, "titulo DESC");
		if (cursor != null) {
			while (cursor.moveToNext()) {

				b.setId(cursor.getInt(cursor
						.getColumnIndex("_id")));
				b.setTitulo(cursor.getString(cursor
						.getColumnIndex("titulo")));
				b.setAutor(cursor.getString(cursor
						.getColumnIndex("autor")));
				b.setEstado(cursor.getString(cursor
						.getColumnIndex("estado")));
				b.setIsbn(cursor.getString(cursor
						.getColumnIndex("isbn")));
				b.setPaginas(cursor.getInt(cursor
						.getColumnIndex("paginas")));
				b.setValoracion(cursor.getLong(cursor
						.getColumnIndex("valoracion")));
			}
		}
		return b;
	}

	public static int insert(Book book) {

		uri = Uri.parse(
                "content://com.example.booksprovider/book");
		  ContentValues valores = new ContentValues();
		  valores.put("titulo", book.getTitulo());
		  valores.put("autor", book.getAutor());
		  valores.put("estado", book.getEstado());
		  valores.put("isbn", book.getIsbn());
		  valores.put("valoracion", book.getValoracion());
		  valores.put("paginas", book.getPaginas());
		  try {
		         Uri u = activity.getContentResolver().insert(uri, valores);
		         //return u.getPathSegments().get(1);
		         return (int) ContentUris.parseId(u);
		  } catch (Exception e) {
		         Toast.makeText(activity,   "Verificar que est instalado "+
		          "com.example.bookprovider",Toast.LENGTH_LONG).show();
		         Log.e("Libreria", "Error: " + e.toString(), e);
		         return -1;
		  }
	}


	public static void update(Book book) {

		uri = Uri.parse(
                "content://com.example.booksprovider/book/"+book.getId());
		  ContentValues valores = new ContentValues();
		  valores.put("titulo", book.getTitulo());
		  valores.put("autor", book.getAutor());
		  valores.put("estado", book.getEstado());
		  valores.put("isbn", book.getIsbn());
		  valores.put("valoracion", book.getValoracion());
		  valores.put("paginas", book.getPaginas());
		  try {
		         activity.getContentResolver().update(uri, valores,null,null);
		  } catch (Exception e) {
		         Toast.makeText(activity,   "Verificar que est instalado "+
		          "com.example.bookprovider",Toast.LENGTH_LONG).show();
		         Log.e("Libreria", "Error: " + e.toString(), e);
		  }
	}

	public static void borrar(int id) {
		//Borrar de Loan
		uri = Uri.parse(
                "content://com.example.booksprovider/book/"+id);

		activity.getContentResolver().delete(uri, null, null);
	}

	public static int size() {
		uri = Uri.parse(
                "content://com.example.booksprovider/book");
		Cursor cursor = activity.getContentResolver().query(uri, null, null,
				null, null);
		if (cursor != null) {
			return cursor.getCount();
		}
		return 0;
	}

	
	public static Vector<Book> listBooks(String orden) {
		Vector<Book> result = new Vector<Book>();
		Book b = new Book();
		uri = Uri.parse(
                "content://com.example.booksprovider/book");
		Cursor cursor = activity.getContentResolver().query(uri, null, null,
				null, orden);
		if (cursor != null) {
			while (cursor.moveToNext()) {
				b = new Book();
				b.setId(cursor.getInt(cursor
						.getColumnIndex("_id")));
				b.setTitulo(cursor.getString(cursor
						.getColumnIndex("titulo")));
				b.setAutor(cursor.getString(cursor
						.getColumnIndex("autor")));
				b.setEstado(cursor.getString(cursor
						.getColumnIndex("estado")));
				b.setIsbn(cursor.getString(cursor
						.getColumnIndex("isbn")));
				b.setPaginas(cursor.getInt(cursor
						.getColumnIndex("paginas")));
				b.setValoracion(cursor.getLong(cursor
						.getColumnIndex("valoracion")));

				result.add(b);
			}
		}
		return result;
	}

}
