package com.example.libreria.controller;

import com.example.libreria.entities.Contact;

import android.app.Activity;
import android.database.Cursor;
import android.provider.ContactsContract.CommonDataKinds.Phone;
import android.provider.ContactsContract.Data;

public class ContactController {

	public static Activity ac;
	
	
	public static Contact getContact(int contactid) {
		
		int colIdx;
		
		// Query: contacts with phone sorted by name
		Cursor mCursor = ac.getContentResolver().query(
				Data.CONTENT_URI,
				new String[] { Data._ID, Data.DISPLAY_NAME, Phone.NUMBER,
						Phone.TYPE , Data.LOOKUP_KEY},
				Data.MIMETYPE + "='" + Phone.CONTENT_ITEM_TYPE + "' AND "
						+ " Data._ID="+contactid,
				//+ " lookup="+contactid,
						null,
				Data.DISPLAY_NAME + " ASC");
		
		if(mCursor.getCount()==0){
			return null;
		}
		else {
			mCursor.moveToFirst();
			Contact c = new Contact();
			colIdx = mCursor.getColumnIndex(Data._ID);
			c.setId(mCursor.getInt(colIdx));
			
			colIdx = mCursor.getColumnIndex(Data.LOOKUP_KEY);
			c.setLookup(mCursor.getString(colIdx));
			
			colIdx = mCursor.getColumnIndex(Phone.NUMBER);
			c.setNumber(mCursor.getString(colIdx));
			
			colIdx = mCursor.getColumnIndex(Data.DISPLAY_NAME);
			c.setName(mCursor.getString(colIdx));
			return c;
		}

	}
	
public static Contact getContactByLookUp(int contactid) {
		
		int colIdx;
		
		// Query: contacts with phone shorted by name
		Cursor mCursor = ac.getContentResolver().query(
				Data.CONTENT_URI,
				new String[] { Data._ID, Data.DISPLAY_NAME, Phone.NUMBER,
						Phone.TYPE , Data.LOOKUP_KEY},
				Data.MIMETYPE + "='" + Phone.CONTENT_ITEM_TYPE + "' AND "
						//+ " Data._ID="+contactid,
				+ Data.LOOKUP_KEY+"="+contactid,
						null,
				Data.DISPLAY_NAME + " ASC");
		
		if(mCursor.getCount()==0){
			return null;
		}
		else {
			mCursor.moveToFirst();
			Contact c = new Contact();
			colIdx = mCursor.getColumnIndex(Data._ID);
			c.setId(mCursor.getInt(colIdx));
			
			colIdx = mCursor.getColumnIndex(Data.LOOKUP_KEY);
			c.setLookup(mCursor.getString(colIdx));
			
			colIdx = mCursor.getColumnIndex(Phone.NUMBER);
			c.setNumber(mCursor.getString(colIdx));
			
			colIdx = mCursor.getColumnIndex(Data.DISPLAY_NAME);
			c.setName(mCursor.getString(colIdx));
			return c;
		}

	}


	
}
