package com.example.libreria.controller;

import java.util.Date;
import java.util.Vector;

import android.app.Activity;
import android.content.ContentValues;
import android.database.Cursor;
import android.net.Uri;
import android.util.Log;
import android.widget.Toast;

import com.example.libreria.entities.Book;
import com.example.libreria.entities.Loan;

public class LoanController {
	public static Activity activity;
	private static Uri uri;

	public LoanController(Activity activity) {
		LoanController.activity = activity;
	}

	public static Loan elemento(int id) {

		Loan l = new Loan();
		uri = Uri.parse("content://com.example.loansprovider/loan/" + id);

		Cursor cursor = activity.getContentResolver().query(uri, null, null,
				null, null);
		if (cursor != null) {
			while (cursor.moveToNext()) {

				l.setId(cursor.getInt(cursor.getColumnIndex("_id")));
				l.setBook(BookController.elemento(cursor.getInt(cursor
						.getColumnIndex("bookid"))));
				l.setName(cursor.getString(cursor.getColumnIndex("name")));
				l.setContactid(cursor.getInt(cursor.getColumnIndex("contactid")));
				 //l.setDate(Date.parse(new String(cursor.getInt("date"))));
				l.setDate(new Date(cursor.getLong(cursor.getColumnIndex("date"))));

			}
		}
		return l;
	}

	public static void anyade(Loan loan) {

		uri = Uri.parse("content://com.example.loansprovider/loan");
		ContentValues valores = new ContentValues();
		valores.put("bookid", loan.getBook().getId());
		valores.put("name", loan.getName());
		valores.put("date", loan.getDate().toString());
		valores.put("contactid", loan.getContactid());
		try {
			activity.getContentResolver().insert(uri, valores);

			// Actualizar status libro
			Book b = BookController.elemento(loan.getBook().getId());
			b.setEstado("L");
			BookController.update(b);
		} catch (Exception e) {
			Toast.makeText(
					activity,
					"Verificar que est instalado "
							+ "com.example.loanprovider", Toast.LENGTH_LONG)
					.show();
			Log.e("Libreria", "Error: " + e.toString(), e);
		}
	}

	public static void update(Loan loan) {

		uri = Uri.parse("content://com.example.loansprovider/loan/"
				+ loan.getId());
		ContentValues valores = new ContentValues();
		valores.put("bookid", loan.getBook().getId());
		valores.put("date", loan.getDate().toString());
		valores.put("name", loan.getName());
		valores.put("contactid", loan.getContactid());
		try {
			activity.getContentResolver().update(uri, valores, null, null);
		} catch (Exception e) {
			Toast.makeText(
					activity,
					"Verificar que est instalado "
							+ "com.example.loanprovider", Toast.LENGTH_LONG)
					.show();
			Log.e("Libreria", "Error: " + e.toString(), e);
		}
	}

	public static void borrar(int id) {

		uri = Uri.parse("content://com.example.loansprovider/loan/" + id);

		activity.getContentResolver().delete(uri, null, null);
	}

	public static int size() {
		uri = Uri.parse("content://com.example.loansprovider/loan");
		Cursor cursor = activity.getContentResolver().query(uri, null, null,
				null, null);
		if (cursor != null) {
			return cursor.getCount();
		}
		return 0;
	}

	public static Vector<Loan> listLoans(String orden) {
		Vector<Loan> result = new Vector<Loan>();
		Loan l = new Loan();
		uri = Uri.parse("content://com.example.loansprovider/loan");
		Cursor cursor = activity.getContentResolver().query(uri, null, null,
				null, orden);
		if (cursor != null) {
			while (cursor.moveToNext()) {
				l = new Loan();
				l.setId(cursor.getInt(cursor.getColumnIndex("_id")));
				l.setBook(BookController.elemento(cursor.getInt(cursor
						.getColumnIndex("bookid"))));
				l.setContactid(cursor.getInt(cursor.getColumnIndex("contactid")));
				l.setName(cursor.getString(cursor.getColumnIndex("name")));

				result.add(l);
			}
		}
		return result;
	}

	public static Loan elementoByBook(int id) {

		Vector<Loan> result = new Vector<Loan>();
		Loan l = new Loan();
		uri = Uri.parse("content://com.example.loansprovider/loan");
		Cursor cursor = activity.getContentResolver().query(uri, null,
				"bookid=" + id, null, null);
		if (cursor != null) {
			while (cursor.moveToNext()) {
				l = new Loan();
				l.setId(cursor.getInt(cursor.getColumnIndex("_id")));
				l.setBook(BookController.elemento(cursor.getInt(cursor
						.getColumnIndex("bookid"))));
				l.setContactid(cursor.getInt(cursor.getColumnIndex("contactid")));
				l.setName(cursor.getString(cursor.getColumnIndex("name")));

				result.add(l);
			}
		}
		if (result.size() > 0) {
			return result.elementAt(0);
		} else {
			return null;
		}
	}
}
